#ifndef _SK_BASE_H_
#define _SK_BASE_H_

#include "skFilter.h"

/////////////////////////////////////////////////////////////////////
// class SkBase
class SkBase
{
public:
	int k;//index of filter
	int x;
	int y;// x, y, 
	float a;// coefficent
	SkFilterBank *m_pFilterBank;
public:
	SkBase(SkFilterBank *pFilterBank=0) { m_pFilterBank = pFilterBank; }
	int read(FILE *pFile) { fscanf(pFile, "k = %d, x = %d, y = %d, a = %f\n", &k, &x, &y, &a); return 0; } 
	int save(FILE *pFile) { fprintf(pFile, "k = %d, x = %d, y = %d, a = %f\n", k, x, y, a); return 0; } 
	int getType() { assert(m_pFilterBank != 0); return m_pFilterBank->getType(k); }
	double getOrt() { return m_pFilterBank->getOrt(k); }//orientation, 0~PI
	int getHalf() { return m_pFilterBank->getHalf(k); }
	int getValidLength() { return m_pFilterBank->getHalfValidLn(k)*2+1;}
	int getValidWidth() { return m_pFilterBank->getHalfValidWd(k)*2+1;}
	double getOrtUnit() { return m_pFilterBank->getOrtUnit(k);}
	double getAspect() { return m_pFilterBank->getAspect(k); }
	int getScale() { return m_pFilterBank->getScale(k); }
	double getfScale() { return m_pFilterBank->getfScale(k); }
	void setFilterBank(SkFilterBank *pFB) { m_pFilterBank = pFB; }
	SkFilterBank *getFilterBank() { return m_pFilterBank;}
	int getEndX() { return m_pFilterBank->getEndX(k); }
	int getEndY() { return m_pFilterBank->getEndY(k); }

};

#endif