#ifndef _SK_GENERAL_EDGE_H_
#define _SK_GENERAL_EDGE_H_

#include "sfu_canny_edge.h"

extern const char g_pchCannyParamName[];
extern const char g_pchCannyWorkDir[];

class SkCannyEdgeParam
{
public:
	double m_dSigmaStart, m_dSigmaEnd, m_dSigmaStep;//start, end and step of sigma
	double m_dHiThreshStart, m_dHiThreshEnd, m_dHiThreshStep;// -- of high thresh
	//lowThresh = 0.4 * highThresh
public:
	SkCannyEdgeParam();
	int read(const char *name);
	int save(const char *name);
};

int skGeneralEdgeDetector(const char *pchImgName);
int skSfuCannyEdgeDetector(const char *pchImgName);
void skGeneralEdgeDetector(unsigned char *image, int rows, int cols,
         float tlow, float thigh, unsigned char *edge, float *dir_radians, int *magnitude);

int skThinnerEdgeSketch(Matrix<unsigned char> &edge,//the edge
						Matrix<float> &dir_rad,//direction
						Matrix<int> &mag);//magnitude

int skApproximateDeltaXYFromDirection(float *dir_radians,//direction in radius
									  int* delta_x,//delta x
									  int* delta_y,//delat y
									  int rows, int cols);//rows and cols
void non_max_supp(int *mag, int *gradx, int *grady, int nrows, int ncols,
    unsigned char *result); 
void apply_hysteresis(int *mag, unsigned char *nms, int rows, int cols,
        float tlow, float thigh, unsigned char *edge);
int skApproximateDeltaXYFromDirection(float dir_rad,//direction in degree, 0~180
									  int &delta_x,//delta x
									  int &delta_y);//delat y
int skApproximateDeltaXYFromDirection(float *dir_rad,//direction in radius, 0~PI
									  int* delta_x,//delta x
									  int* delta_y,//delat y
									  int rows, int cols);//rows and cols


#endif