
#include "skLineSeg.h"

#define PI 3.1415926


double	maxlinedev(int *pPntListR, int *pPntListC, 
				  int fst, int lst, 
				  int &index, double &D, double &totaldev);

int		mergeseg(int *pPntSegR, int *pPntSegC, int Nseg, 
				 double angtol, int linkrad, int linedevtol);

bool	compareseg(double *seg1, double *seg2, int * newseg, int linkrad, int linedevtol);

void	quickSort_double_int(int Fp, int Lp, double *dList, int *nList);
int skMergeSeg(int *pR, int *pC, int nPtNum, int *pSegEndPt, int nSegNum);

// return seg mum
//   tol = 2;         % Line segments are fitted with maximum deviation from
//		     % original edge of 2 pixels.
//    angtol = 0.05;   % Segments differing in angle by less than 0.05 radians
//    linkrad = 2;     % and end points within 2 pixels will be merged.
int skLineSeg(int *pPntListR, int *pPntListC, int nNumSktPnt,//input row and col, and pt num 
			int *pPntSeg,//seg index, the index of the end of each segment
			double tol, double angtol, int linkrad)
{
	if ( nNumSktPnt == 1 ) { pPntSeg[0] = 0; return 1;}

	int *pPntSegR = new int[nNumSktPnt];//segment point (r,c)
	int *pPntSegC = new int[nNumSktPnt];

	// m segment num, pPntSegR & pPntSegC save m+1 points, includes first and last
	int m = skLineSeg(pPntListR, pPntListC, nNumSktPnt, pPntSegR, pPntSegC, tol, angtol, linkrad);//num of segments

	int n = nNumSktPnt;

	int j = 0;
	for (int k = 1; k < n; k++)
	{//for each list point
		for (int i = 0; i < m+1; i++)
//		for (int i = 1; i < m+1; i++)//why not i=1? Nov. 18
		{//for each seg point
			if (pPntSegR[i] == pPntListR[k] && pPntSegC[i] == pPntListC[k])
			{//find
				pPntSeg[j] = k;
				j++;
				break;
			}
		}

	}

//	assert(j == m);
	if (j > m)//a bug due to Yizhou's code
		m = j;
	assert(pPntSeg[m-1] == n-1);

	delete []pPntSegR;
	delete []pPntSegC;

	m = skMergeSeg(pPntListR, pPntListC, nNumSktPnt, pPntSeg, m); 
	return m;
}
///////////////////
int skMergeSeg(int *pR, int *pC, int nPtNum, int *pSegEndPt, int nSegNum)
{
	if (nSegNum <= 1)
		return nSegNum;

	int i;
	int nDelta;
	for (i = 0; i < nSegNum; i++)
	{
		if (i == 0)
			nDelta = pSegEndPt[0];
		else 
			nDelta = pSegEndPt[i] - pSegEndPt[i-1];
		if ( nDelta <= 1 )
		{//two control point are too close
			if (i < nSegNum - 1)
			{//not the last one
				//remove the second one
				for (int j = i; j < nSegNum - 1; j++)
				{
					pSegEndPt[j] = pSegEndPt[j+1];
				}
				i--;
				nSegNum--;
				if (nSegNum <= 1)
					break;
			}
			else
			{//the last one
				if (nSegNum <= 1)
					break;
				pSegEndPt[i-1] = pSegEndPt[i];
				nSegNum--;
				break;
			}
		}
	}
	return nSegNum;
}

///////////////////
// Fit line segments to the edgelists with the following parameters:
//   tol = 2;         % Line segments are fitted with maximum deviation from
//		     % original edge of 2 pixels.
//    angtol = 0.05;   % Segments differing in angle by less than 0.05 radians
//    linkrad = 2;     % and end points within 2 pixels will be merged.
// return segment number
// pPntSegR,, pPntSegC save the control points of segments, including the first and the end points of the curve
int skLineSeg(int *pPntListR, int *pPntListC, int nNumSktPnt, 
			int *pPntSegR, int *pPntSegC,
			double tol, double angtol, int linkrad)
{
	int nNumSegPnt = 0;
	double m, d, totaldev;
	int i;

//	bool merge = false;
 	bool merge = true;
   
	int fst = 1;                // Indecies of first and last points in edge segment being considered.
	int lst = nNumSktPnt-1;        

	pPntSegR[nNumSegPnt] = pPntListR[0];
	pPntSegC[nNumSegPnt] = pPntListC[0];

	if(fst >= lst)
	{
		nNumSegPnt ++;
		pPntSegR[nNumSegPnt] = pPntListR[lst];
		pPntSegC[nNumSegPnt] = pPntListC[lst];
		return nNumSegPnt;
	}
	
	while(fst < lst) 
	{
	    m = maxlinedev(pPntListR, pPntListC, fst, lst, i, d, totaldev);  // Find size & posn of maximum deviation.
	    

	    while (m > tol)			//While deviation is > tol  (m/d) ?
		{
			lst = i+fst-1;		// Shorten line to point of max deviation by adjusting lst
			m = maxlinedev(pPntListR, pPntListC, fst, lst, i, d, totaldev);
		}
	    //find the first linelet from the beginning point
	    nNumSegPnt ++;				//Record line segment. Note that (c,r) corresponds to (x,y)
	    pPntSegR[nNumSegPnt] = pPntListR[lst];
		pPntSegC[nNumSegPnt] = pPntListC[lst];
	    //Record edgelist that corresponds to the segment.
	    // consider the left part and search again           
	    fst = lst+1;        // Reset fst and lst.
	    lst = nNumSktPnt-1;
	}
	
    
	int nNumMergeSegPnt;
	if (merge)
	{//merge segments
		nNumMergeSegPnt = mergeseg(pPntSegR, pPntSegC, nNumSegPnt, angtol, linkrad, tol);
		pPntSegR[nNumMergeSegPnt] = pPntListR[nNumSktPnt-1];
		pPntSegC[nNumMergeSegPnt] = pPntListC[nNumSktPnt-1];
		
	}
	else
		nNumMergeSegPnt = nNumSegPnt;

	return nNumMergeSegPnt;
}


int	mergeseg(int *pPntSegR, int *pPntSegC, int Nseg, 
			 double angtol, int linkrad, int linedevtol)
{//pPntSegR, pPntSegC save Nseg+1 points, 
	if (Nseg <= 1)
		return Nseg;

	int nNumMergeSegPnt = 0;
	int i, j;
	int pntMergeSegR[4096];
	int pntMergeSegC[4096];

    double cosAngTol = cos(angtol);
 
    // Build up some data in the following form
    // [x1 y1 x2 y2 dx dy angle merged]
    
	double **seg;
	seg = new double *[Nseg];
	for(i = 0; i < Nseg; i ++)
		seg[i] = new double [8];

	double **tmp;
	tmp = new double *[Nseg];
	for(i = 0; i < Nseg; i ++)
		tmp[i] = new double [8];

	double *pdAng;
	pdAng = new double [Nseg];
	
	int *pnOrdIdx;
	pnOrdIdx = new int [Nseg];
	for(i = 0; i < Nseg; i ++)
		pnOrdIdx[i] = i;

	
	for(i = 0; i < Nseg; i ++)
	{
		seg[i][0] = pPntSegC[i];
		seg[i][1] = pPntSegR[i];
		seg[i][2] = pPntSegC[i+1];
		seg[i][3] = pPntSegR[i+1];

		seg[i][4] = pPntSegC[i+1] - pPntSegC[i];     //delta x
		seg[i][5] = pPntSegR[i+1] - pPntSegR[i];	 //delta y
		seg[i][6] = atan2(seg[i][5], seg[i][4]);	//segment angle [-pi ... pi]
		bool neg = seg[i][6] < 0;                   //compress angle range [0...pi]
	    seg[i][6] = seg[i][6] + neg*PI;
	}

	for(i = 0; i < Nseg; i ++)
		pdAng[i] = seg[i][6];

	quickSort_double_int(0, Nseg - 1, pdAng, pnOrdIdx);	//sort by angle

	int nIdx;
	for(i = 0; i < Nseg; i ++)
	{
		nIdx = pnOrdIdx[i];
		for(j = 0; j < 8; j ++)
		{
			tmp[i][j] = seg[nIdx][j];
		}
	}
	for(i = 0; i < Nseg; i ++)
		for(j = 0; j < 8; j ++)
			seg[i][j] = tmp[i][j];//segs are ordered by angle

	for(i = 0; i < Nseg; i ++)
	{
		seg[i][6] = 2 * seg[i][6];	//double the angles
		seg[i][7] = 0;//merged or not
	}
    
    int TotalSegs = Nseg;
    bool merged;
	int newseg[4];
    for (int s1 = 0; s1 < Nseg; s1 ++)
	{
		if (!seg[s1][7])  // if segment s1 has not already been merged
		{
			int s2 = s1+1; //next seg
			if (s2==Nseg)
				break;

			double ang1 = seg[s1][6]; 
			double ang2 = seg[s2][6];
			double deltaSin = sin(ang1)*cos(ang2) - cos(ang1)*sin(ang2);
			double deltaCos = cos(ang1)*cos(ang2) + sin(ang1)*sin(ang2);
			double deltaAng = 0.5*fabs(atan2(deltaSin,deltaCos));
			
			while (deltaAng < angtol)
			{
				if (!seg[s2][7])   // if segment s2 has not already been merged
				{
					merged = compareseg(seg[s1], seg[s2], newseg, linkrad, linedevtol);
					if (merged)
					{
						for(i = 0; i < 4; i ++)
							seg[s1][i] = newseg[i];
						//  update delta x, delta y, and angle ? (I think not)
						seg[s2][7] = merged;  // eliminate s2;
						TotalSegs = TotalSegs - 1;
					}
				}
				s2 = s2+1; 
				if (s2==Nseg)
					break;
				ang2 = seg[s2][6];
				deltaSin = sin(ang1)*cos(ang2) - cos(ang1)*sin(ang2);
				deltaCos = cos(ang1)*cos(ang2) + sin(ang1)*sin(ang2); 
				deltaAng = 0.5*fabs(atan2(deltaSin,deltaCos));
			}
		}	
	}

    
    // Now clean up list by extracting the unmerged entries
    
    nNumMergeSegPnt = 0;
    for (int s = 0; s < Nseg; s ++)
	{
		if (!seg[s][7])					// if this segment has not been merged
		{
			pntMergeSegC[nNumMergeSegPnt] = seg[s][0];  
			pntMergeSegR[nNumMergeSegPnt] = seg[s][1];  
			nNumMergeSegPnt ++;		
		}
	}

	

	for(i = 0; i < nNumMergeSegPnt; i ++)
	{
		pPntSegR[i] = pntMergeSegR[i];
		pPntSegC[i] = pntMergeSegC[i];
	}

	pPntSegR[i] = pPntSegR[Nseg+1];
	pPntSegC[i] = pPntSegC[Nseg+i];

	for(i = 0; i < Nseg; i ++)
		delete [] seg[i];
	delete seg;

	for(i = 0; i < Nseg; i ++)
		delete [] tmp[i];
	delete tmp;

	delete [] pdAng;

	delete [] pnOrdIdx;

	return nNumMergeSegPnt;
}


bool compareseg(double *seg1, double *seg2, int * newseg, int linkrad, int linedevtol)
{
    bool merged;

	double s1p1[2], s1p2[2], s2p1[2], s2p2[2];
	double dir1[2], dir2[2], tmp[2];
	
    s1p1[0] = seg1[0];	// point1 of segment1
    s1p1[1] = seg1[1];	

    s1p2[0] = seg1[2];	// point1 of segment1
    s1p2[1] = seg1[3];	
    
    s2p1[0] = seg2[0];	// point1 of segment2
    s2p1[1] = seg2[1];	

    s2p2[0] = seg2[2];	// point2 of segment2
    s2p2[1] = seg2[3];	


    dir1[0] = seg1[4];
    dir1[1] = seg1[5];
    dir2[0] = seg2[4];
    dir2[1] = seg2[5];
    
    double cosAng = dir1[0] * dir2[0] + dir1[1] * dir2[1];
    
    if (cosAng < 0)          //Reverse order of points on seg2 so that both
    {                       // segments are in the `same' direction
        tmp[0]  = s2p1[0];
        tmp[1]  = s2p1[1];
		s2p1[0] = s2p2[0];
		s2p1[1] = s2p2[1];
		s2p2[0] = tmp[0];
		s2p2[1] = tmp[1];
    }

    merged = 0;							// Default result: not merged
    newseg[0] = seg1[0];			//  and segments left unchanged
	newseg[1] = seg1[1];
	newseg[2] = seg2[0];
	newseg[3] = seg2[1];

	double dNorm1 = sqrt((s1p2[0]-s2p1[0])*(s1p2[0]-s2p1[0]) + (s1p2[1]-s2p1[1])*(s1p2[1]-s2p1[1]));
	double dNorm2 = sqrt((s2p2[0]-s1p1[0])*(s2p2[0]-s1p1[0]) + (s2p2[1]-s1p1[1])*(s2p2[1]-s1p1[1]));
	int rc1[4];
	int rc2[4];
	double maxdev;
	int index;
	double D, totaldev;
    if (dNorm1 < linkrad)       // If we satisfy endpoint proximity
	{
		rc1[0] = s1p1[0]; rc2[0] = s1p1[1];
		rc1[1] = s1p2[0]; rc2[1] = s1p2[1];
		rc1[2] = s2p1[0]; rc2[2] = s2p1[1];
		rc1[3] = s2p2[0]; rc2[3] = s2p2[1];
		
		maxdev = maxlinedev(rc1,rc2,0,3,index,D,totaldev);  // test line deviation
		if (maxdev < linedevtol)
		{
			newseg[0] = s1p1[0]; newseg[1] = s1p1[1];       // Merge the segments one way
			newseg[2] = s2p2[0]; newseg[3] = s2p2[1];
			merged = 1;
		}
	}
	else if (dNorm2 < linkrad)
	{
		rc1[0] = s2p1[0]; rc2[0] = s2p1[1];
		rc1[1] = s2p2[0]; rc2[1] = s2p2[1];
		rc1[2] = s1p1[0]; rc2[2] = s1p1[1];
		rc1[3] = s1p2[0]; rc2[3] = s1p2[1];
		maxdev = maxlinedev(rc1,rc2,0,3,index,D,totaldev);
		if (maxdev < linedevtol)
		{
			newseg[0] = s2p1[0]; newseg[1] = s2p1[1];       // ... or merge the other way.
			newseg[2] = s1p2[0]; newseg[3] = s1p2[1];
			merged = 1;	
		}
	}

	return merged;
}

double	maxlinedev(int *pPntListR, int *pPntListC, 
				  int fst, int lst, 
				  int &index, double &D, double &totaldev)
{
	double maxdev = -10000000000;
	int y1my2, x2mx1, C, i;
	
	int Npts = lst - fst + 1;
	assert(Npts >= 0);
    
	double *d;
	d = new double [Npts];

    if (Npts == 1)
	{
		//MessageBox(NULL,'Contour of length 1!',"Error",MB_OK);
		maxdev = 0; index = 0; D = 1;
		delete []d;
		return maxdev;
	}
    else if(Npts == 0)
	{
//		printf("ERROR: Contour of length 0!");
//		exit(0);
		maxdev = 0; index = 0; D = 1;
		delete []d;
		return 0;
	}
    
    // Eqn of line joining end pts (x1 y1) and (x2 y2) can be parameterised by
    //    x*(y1-y2) + y*(x2-x1) + y2*x1 - y1*x2 = 0
    
    
    y1my2 = pPntListR[fst] - pPntListR[lst];                       // Pre-compute parameters
    x2mx1 = pPntListC[lst] - pPntListC[fst];
	
    C = pPntListR[lst] * pPntListC[fst] - pPntListR[fst] * pPntListC[lst];
    
    D = sqrt(double((pPntListR[lst] - pPntListR[fst])*(pPntListR[lst] - pPntListR[fst])
		+ (pPntListC[lst] - pPntListC[fst])*(pPntListC[lst] - pPntListC[fst]))); // Distance between end points
    
	// Distance from line segment for each contour point
	for(i = 0; i < Npts; i ++)
		d[i] = fabs(double(pPntListC[fst+i] * y1my2 + pPntListR[fst+i] * x2mx1 + C))/D;           

	index = 0;
	for(i = 0; i < Npts; i ++)
	{
		if(d[i] > maxdev)
		{
			maxdev = d[i];
			index = i;
		}
	}

	totaldev = 0;
	for(i = 0; i < Npts; i ++)
		totaldev += d[i];

	delete []d;
	return maxdev;
}

void quickSort_double_int(int Fp, int Lp, double *dList, int *nList)
{
    int Lower, Middle;
    double Thresh;
	double dtmp;
	int ntmp;
    int i;

    if ( Fp < Lp )
    {
		Thresh = dList[Lp];

		/*  Isolate all items with values > threshold  */

		Middle = Fp;

		for ( i = Fp ; i < Lp ; i++ )
		{
			if ( dList[i] < Thresh ) //ascending order
			{
				if ( i != Middle ) 
				{
					//(*Exchange)(Middle, i);
					dtmp = dList[Middle];
					dList[Middle] = dList[i];
					dList[i] = dtmp;

					ntmp = nList[Middle];
					nList[Middle] = nList[i];
					nList[i] = ntmp;
				}
				Middle++;
			}
		}

		/*  Extract all values equal to the threshold  */

		Lower = Middle - 1;

		for ( i = Lower ; i >= Fp ; i-- )
		{
			if ( dList[i] == Thresh )
			{
				if ( i != Lower ) 
				{
					//(*Exchange)(Lower, i);
					dtmp = dList[Lower];
					dList[Lower] = dList[i];
					dList[i] = dtmp;

					ntmp = nList[Lower];
					nList[Lower] = nList[i];
					nList[i] = ntmp;
				}
				Lower--;
			}
		}

		/*  Sort the lower values  */

		quickSort_double_int(Fp, Lower, dList, nList);

		/*  Position the middle element  */

		//(*Exchange)(Middle, Lp);
		if (Middle != Lp)
		{
			dtmp = dList[Middle];
			dList[Middle] = dList[Lp];
			dList[Lp] = dtmp;

			ntmp = nList[Middle];
			nList[Middle] = nList[Lp];
			nList[Lp] = ntmp;
		}

		/*  Sort the higher values  */

		quickSort_double_int(Middle+1, Lp, dList, nList);
	}
}
