#ifndef _SK_LINK_LIST_H_
#define _SK_LINK_LIST_H_


template<class T>
class SkLinkList
{
public:
	T *m_pHead;
	T *m_pTail;
	SkLinkList<T> *m_pNext, *m_pPrev;//could be in another link list
	int m_nSize;
	// operations
public:
	SkLinkList();
	~SkLinkList();
	void removeAll();
	void addHead( T *p );
	void addTail( T *p );
	int getSize();
	void remove( T* p );
	T *getHead() { return m_pHead; }
	T *getTail() { return m_pTail; }
};
template<class T>
SkLinkList<T>::SkLinkList()
{
	m_pNext = 0;
	m_pPrev = 0;
	m_pHead = 0;
	m_pTail = 0;
	m_nSize = 0;
}
template<class T>
SkLinkList<T>::~SkLinkList()
{
	removeAll();
}
template<class T>
void SkLinkList<T>::removeAll()
{
	T *p= m_pHead;
	while ( p != 0 )
	{
		T *pHead = p->m_pNext;
		p->m_pNext = 0;
		p->m_pPrev = 0;
		delete p;
		p = pHead;
	}
	m_pHead = 0;
	m_pTail = 0;
	m_nSize = 0;
}
template<class T>
void SkLinkList<T>::addHead( T *p )
{
	if( m_pHead == 0 && m_pTail == 0 )
	{
		m_pHead = p;
		m_pTail = p;
		p->m_pNext = 0;
		p->m_pPrev = 0;
	}
	else
	{
		T *pOldHead = m_pHead;
		m_pHead = p;
		pOldHead->m_pPrev = m_pHead;
		m_pHead->m_pNext = pOldHead;
		m_pHead->m_pPrev = 0;
	}
	m_nSize++;
}
template<class T>
void SkLinkList<T>::addTail( T *p )
{
	if( m_pHead == 0 && m_pTail == 0 )
	{
		m_pHead = p;
		m_pTail = p;
		p->m_pNext = 0;
		p->m_pPrev = 0;
	}
	else
	{
		T *pOldTail = m_pTail;
		m_pTail = p;
		pOldTail->m_pNext = m_pTail;
		m_pTail->m_pPrev = pOldTail;
		m_pTail->m_pNext = 0;
	}
	m_nSize++;
}
template<class T>
int SkLinkList<T>::getSize()
{
	return m_nSize;
}
template<class T>
void SkLinkList<T>::remove( T* p )
{
	if( p == m_pHead )
	{
		m_pHead = m_pHead->m_pNext;
		if (m_pHead != 0)
			m_pHead->m_pPrev = 0;
	}
	else if( p == m_pTail )
	{
		m_pTail = m_pTail->m_pPrev;
		if (m_pTail != 0)
			m_pTail->m_pNext = 0;
	}
	else
	{
		T* p1 = p->m_pPrev;
		T* p2 = p->m_pNext;
		p1->m_pNext = p2;
		p2->m_pPrev = p1;
	}
	delete p;

	m_nSize--;
}

#endif //_SK_LINK_LIST_H_
