#ifndef _SK_LOCAL_HIST_H_
#define _SK_LOCAL_HIST_H_

#include "skFilterCoef.h"
#include "skAdaptHis.h"
#include "skMatrix.h"

class SkLocalHist
{
public:
	SkFilterCoef	*m_pFC;//pointer to the FilterCoef
	Matrix<CAdaptHis> *m_pHisMat;//pointer to the matrix of histograms
	int			m_nHalfLocalSize;//the half local size on which the histograms apply
	int			m_nSub;//sub sample image, to save the space, we don't compute the hist for each pixel, only for sub-sample ones
private:
	int			m_nFilterNum;
public:
	SkLocalHist();
	~SkLocalHist();
	int			getFilterNum() { return m_nFilterNum; }
	int			getHistImgWidth() { if (m_pHisMat==0) return 0; else return m_pHisMat[0].cols();}
	int			getHistImgHeight() { if (m_pHisMat==0) return 0; else return m_pHisMat[0].rows();}
	void		setFilterCoef(SkFilterCoef *pFC){m_pFC=pFC;}
	void		setHalfLocalSize(int s) {m_nHalfLocalSize = s;}
	void		setSubSampleRate(int s) {m_nSub = s; }
	int 		build(SkFilterCoef *pFC, Matrix<float> *pValid=0);
	static int	setHistogramLowerUpperLimitsAndBinNum(int k, double &dLowerLimit, double &dUpperLimit, int &nBinNum);

};
class SkTextureCluster
{
public:
	static int clustering(SkLocalHist *pLocalHis, Matrix<float> &cluster, int nMaxClusterNum);
};

#endif