#ifndef _SK_NBR_MANAGER_H_
#define _SK_NBR_MANAGER_H_

#include "skMap.h"

#ifndef PI 
#define PI 3.14159265 
#endif
/////////////////////////////////////////////////////////////////////
// class SkNbrManager: manage the nbrs of a token map

//#define MAX_OUT_NBR_NUM 2

class SkNbrManager
{
public:
	static int constructParentChildNbrhood(SkBaseMap* pMapPrt, SkBaseMap* pMapChd);
	static int constructParentChildNbrhood(SkBaseNode* pBaseNode, SkBaseMap* pMapChd, SkBaseMap* pMapPrt, int nScale);
	static int addNodeAsChildOfItsParents(SkBaseNode* pBaseNode, SkBaseMap* pMapPrt);
	static int findNearestNode(SkBaseMap* pMap, int x, int y, SkBaseNode** pNodes, int nMaxOutNbrNum, double dMinCoef=0);
	static int constructNbrhood(SkBaseMap* pBaseMap, int nMaxOutNbrNum, int nPartial=0);
	static int constructNbrhood(SkBaseNode *pNode, SkBaseMap* pBaseMap, int nMaxOutNbrNum, int nPartial=0);
	static int addNodeAsInNbr2ItsOutNbrs(SkBaseNode *pNode, SkBaseMap *pMap);
	static SkBaseNode *findFirstBase(SkBaseMap *pMap);
	static bool after(SkBaseNode *pNode, int x0, int y0);
	static bool after(SkBaseNode *pNode, SkBaseNode *pNode0);
	static bool existNode(int x0, int y0, SkBaseMap *pMap, double dDis);
	static int moveAdjacientBases(SkBaseMap *pBaseMap, double dMinDis);
	// nbrType: 0-outnbr, 1-prtnbr, 2-chdnbr, 3-inNbr; 
	// indexType: 0-distance, 1-direction, 2-BiBaseProb, 3-BiBaseCluster, 4-nbrID, 5-uniBaseProb, 6-uniBaseCluster
	static int sortNbr(SkBaseMap *pMap, int nbrType, int indexType);
	//	nbrType: 0-outnbr, 1-prtnbr, 2-chdnbr; 
	//	indexType: (must be)5-uniBaseCluster, all others not defined
	static int sortNbrByUniBaseProperty(SkBaseNode *pNode, SkBaseMap *pBaseMap, int nbrType, int indexType=5);
	// May 19, 2002
	static int findCloseNodeIDs(int x0, int y0, int *pnNbrIDs, SkBaseMap *pBaseMap, double dMaxDis);
	// July 31, 2002
	static int setElectronsAsNearestNucleusOutNbr(SkBaseMap* pBaseMap, double dMaxDis);
	static int setElectronsAsNearestNucleusOutNbr(SkBaseNode* pNode0, SkBaseMap* pBaseMap, double dMaxDis);
	static int setElectronsAndNucleusAndBuildOutNbrhood(SkBaseMap* pBaseMap, double dMaxDis);
	static int setElectronsAndNucleusAndBuildOutNbrhood(SkBaseNode* pNode0, SkBaseMap* pBaseMap, double dMaxDis);

	static int addNbr(SkBaseNode *pNode, SkBaseNode *pNbr, int nNbrType, int n=-1);
	static int removeThisNodeFromItsNbrs(SkBaseNode *pNode, SkBaseMap* pBaseMap, int nbrType);

};
#endif
