#include <stdio.h>

#include "skPrim.h"

int SkPrimSmbMap::save(const char* name)
{
	FILE *pFile;
	pFile = fopen( name, "w" );
	if( pFile == NULL )
	{
//		::MessageBox( NULL, "Write token file failure", "File error", MB_OK );
		return 1;
	}
	fprintf( pFile, "image width = %d image height = %d \n", m_nImgWd, m_nImgHt );
	int nSize = m_nPrimNum;
	fprintf( pFile, "prim num = %d \n\n", nSize );
	for( int i = 0; i < m_nPrimNum; i++ )
	{
		fprintf( pFile, "prim %d:\n", i);
		fprintf( pFile, "    branch num = %d center: x = %d y = %d\n", m_pPrim[i].d, m_pPrim[i].c.x, m_pPrim[i].c.y );
		fprintf( pFile, "                branch ends: ");
		for (int j = 0; j < m_pPrim[i].d; j++)
		{
			fprintf( pFile, "(%d, %d) ", m_pPrim[i].p[j].x, m_pPrim[i].p[j].y );
		}
		fprintf( pFile, "  EndPoint = %d\n\n",m_pPrim[i].m_nEndPoint);
	}
	fclose( pFile );

	return 0;
}
int SkPrimSmbMap::read(const char* name)
{
	FILE *pFile;
	pFile = fopen( name, "r" );
	if( pFile == NULL )
	{
//		::MessageBox( NULL, "Write token file failure", "File error", MB_OK );
		return 1;
	}
	fscanf( pFile, "image width = %d image height = %d \n", &m_nImgWd, &m_nImgHt );
	fscanf( pFile, "prim num = %d \n\n", &m_nPrimNum );
	int ii;
	for( int i = 0; i < m_nPrimNum; i++ )
	{
		fscanf( pFile, "prim %d:\n", &ii);
		fscanf( pFile, "    branch num = %d center: x = %d y = %d\n", &(m_pPrim[i].d), &(m_pPrim[i].c.x), &(m_pPrim[i].c.y) );
		fscanf( pFile, "                branch ends: ");
		for (int j = 0; j < m_pPrim[i].d; j++)
		{
			fscanf( pFile, "(%d, %d) ", &(m_pPrim[i].p[j].x), &(m_pPrim[i].p[j].y) );
		}
		fscanf( pFile, "  EndPoint = %d\n\n", &(m_pPrim[i].m_nEndPoint));
	}
	fclose( pFile );
	return 0;
}
