#ifndef _SK_PRIM_H_
#define _SK_PRIM_H_

class SkPrimPoint
{
public:
	int x, y;
};
#define SK_MAX_BRANCH 5
class SkPrimSmb//symbolic primitive
{
public:
	int d;//degree
	SkPrimPoint c;//center
	SkPrimPoint p[SK_MAX_BRANCH];//p[0~3], branch ends 
	int m_nEndPoint;
public:
	SkPrimSmb() { clear(); }
	void clear() {d = 0; c.x = 0; c.y = 0; }
	int setCenter(int x, int y) { c.x = x; c.y = y; d = 0; return d; }
	int addBranch(int x, int y) { if (d >= SK_MAX_BRANCH) return d; p[d].x = x-c.x; p[d].y = y-c.y; d++; return d; }
	int removeBranch(int b) {for (int i = b; i < d-1; i++) p[i] = p[i+1]; d--; return d; }//b: branch index 0~3
};
class SkPrimSmbMap
{
public:
	int m_nPrimNum;
	SkPrimSmb m_pPrim[4096];
	int m_nImgWd, m_nImgHt;
public:
	SkPrimSmbMap() { m_nPrimNum = 0; m_nImgWd = 0, m_nImgHt = 0;}
	int add(SkPrimSmb &prim) {m_pPrim[m_nPrimNum] = prim; m_nPrimNum++; return m_nPrimNum; }
	int removeLast() {m_nPrimNum--; if (m_nPrimNum < 0) m_nPrimNum = 0; return m_nPrimNum; }
	void setImageSize(int w, int h) {m_nImgWd = w; m_nImgHt = h; }
	int save(const char* name);
	int read(const char* name);
};

#endif//_SK_PRIM_H_
