#ifndef _SUSAN2J_H_
#define _SUSAN2J_H_

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <malloc.h>      /* may want to remove this line */

#ifndef PPC
typedef int        TOTAL_TYPE; /* this is faster for "int" but should be "float" for large d masks */
#else
typedef float      TOTAL_TYPE; /* for my PowerPC accelerator only */
#endif

/*#define GNUDOS*/           /* uncomment if using djgpp gnu C for DOS */
#define SEVEN_SUPP           /* size for non-max corner suppression; SEVEN_SUPP or FIVE_SUPP */
#define MAX_CORNERS   15000  /* max corners per frame */

/* ********** Leave the rest - but you may need to remove one or both of sys/file.h and malloc.h lines */

#define  exit_error(IFB,IFC) { fprintf(stderr,IFB,IFC); exit(0); }
#define  FTOI(a) ( (a) < 0 ? ((int)(a-0.5)) : ((int)(a+0.5)) )
typedef  unsigned char uchar;
typedef  struct {int x,y,info, dx, dy, I;} CORNER_LIST[MAX_CORNERS];


void int_to_uchar(uchar *r, int *in, int size);
void edge_draw(uchar *in, uchar *mid, int x_size, int y_size, int drawing_mode);
void corner_draw(uchar *in, CORNER_LIST corner_list, int x_size, int drawing_mode);
void setup_brightness_lut(uchar **bp, int thresh, int form);
void susan_smoothing(int three_by_three, uchar *in, float dt, int x_size, int y_size, uchar* bp);
void susan_principle(uchar *in, int *r, uchar *bp, int max_no, int x_size, int y_size);
void susan_principle_small(uchar *in, int *r, uchar *bp, int max_no, int x_size, int y_size);
void susan_edges(uchar *in, int *r, uchar *mid, uchar *bp, int max_no, int x_size, int y_size);
void susan_edges_small(uchar *in, int *r, uchar *mid, uchar *bp,
					   int max_no, int x_size, int y_size);
void susan_thin(int *r, uchar *mid, int x_size,int y_size);
void susan_corners(uchar *in,int *r,uchar *bp, int max_no, CORNER_LIST corner_list, int x_size, int y_size);
void susan_corners_quick(uchar *in, int *r, uchar *bp, int max_no, CORNER_LIST corner_list, int x_size, int y_size);

#endif